/************************************************************************
 *	Read COPYRIGHT file in this directory				*
 ************************************************************************/

/************************************************************************
 *  Definitions common to every protocol.				*
 ************************************************************************/

#include "sizes.h"
#include "packets.h"			/*  "MPID_PKT_etc.etc."  */
#include "queue.h"			/*  "MPID_QEL"  */
#include <linux/gamma/libgamma.h>

#define AG_DEBUG  0
#define AGS_DEBUG 0
#define AGR_DEBUG 0

#define USE_GAMMA_FLOWCTL
#undef USE_GAMMA_ISEND

#ifdef USE_GAMMA_FLOWCTL
#define GAMMASEND(a,b,c) gamma_send_flowctl(a,b,c)
#define GAMMASEND_2P(a,b,c,d,e) gamma_send_2p_flowctl(a,b,c,d,e)
/*  Cannot use flow-controlled gamma_sends inside recv handlers...  */
#define GAMMASEND_2P_FOR_HANDLER(a,b,c,d,e) gamma_send_2p(a,b,c,d,e)
#define GAMMAISEND_2P(a,b,c,d,e) gamma_isend_2p_flowctl(a,b,c,d,e)
#else
#define GAMMASEND(a,b,c) gamma_send(a,b,c)
#define GAMMASEND_2P(a,b,c,d,e) gamma_send_2p(a,b,c,d,e)
#define GAMMASEND_2P_FOR_HANDLER(a,b,c,d,e) gamma_send_2p(a,b,c,d,e)
#define GAMMAISEND_2P(a,b,c,d,e) gamma_isend_2p(a,b,c,d,e)
#endif

#define AG_NEWMSG_SEM 1000		/*  Must be > 2*(max # of nodes)  */
#define AG_1 999 
#define AG_2 998

typedef struct {
	unsigned long src;
	MPIR_RHANDLE *rhandle;	/*
				 *  Ptr to an rhandle of an EXPECTED message.
				 */
	volatile int unexp_entry;
				/*
				 *  == -1 means "msg was expected".
				 *  > -1 means "msg was unexpected". In this
				 *  case, it is the index of an entry into
				 *  the unexpected queue.
				 */
	void *temp_buf;		/*
				 *  Ptr to a temporary buffer where an
				 *  UNEXPECTED message has been stored.
				 */
} AG_queue_entry;
typedef unsigned char * AG_buf;
typedef struct {
	MPID_PKT_T p;
/*
	unsigned char pad_to_cache_line[16-sizeof(MPID_PKT_HEAD_T)];
*/
} AG_pkt_q_entry;

extern AG_queue_entry	*AG_src_queue;
extern AG_pkt_q_entry	*AG_pkt_queue;
extern unsigned long	AG_head, AG_tail;
extern AG_buf		*AG_buffer;
extern void		*AG_tempbuf_ptr;
extern MPID_PKT_HEAD_T	AG_pkt;
extern time_586		AG_time_origin,AG_time;

extern time_586 a,b;

void AG_handler_rec(void);
void AG_handler_err(void);

int MPID_CH_Rndvb_send
        ANSI_ARGS(( void *, int, int, int, int, int, MPID_Msgrep_t ));
int MPID_CH_Rndvb_isend
        ANSI_ARGS(( void *, int, int, int, int, int, MPID_Msgrep_t,
        MPIR_SHANDLE * ));
int MPID_CH_Rndvb_ack_freed
        ANSI_ARGS(( void *, int ));

/************************************************************************
 *  Special definitions for rendez-vous protocol.			*
 ************************************************************************/

extern unsigned long		AGR_send_id;
extern AG_buf			*AGR_buffer;
void				AGR_handler_rec(void);
