/************************************************************************
 *	Read COPYRIGHT file in this directory				*
 ************************************************************************/

#include <asm/page.h>	 /*  "#define PAGE_SIZE ..."  */

#undef AG_HARDMEMLOCK

#ifdef AG_HARDMEMLOCK

#define AG_MAXLOCK 8192	/*
			 *  Size of the table of pinned-down
			 *  send/receive buffers.
			 */
typedef struct {
	void *addr;
	unsigned long len;
	unsigned long in_use;
} AG_lock_entry;

typedef struct {
	unsigned long head;
	unsigned long how_many;
	AG_lock_entry *table;
} AG_lock_table;

extern AG_lock_table	AG_lock;
int _AG_mlock(void *buf,unsigned long size);
void _AG_munlock(void *buf, unsigned long size);
#define AG_mlock(buf,size) {if ((size)>0) _AG_mlock((buf),(size));}
#define AG_munlock(buf,size) {if ((size)>0) _AG_munlock((buf),(size));}

#else

#define AG_mlock(buf,size) \
if (size>0) { \
	unsigned char *p = (unsigned char *)buf; \
	unsigned char *q = p; \
	unsigned char *end = (unsigned char *) \
		(((unsigned long)(p+size-1+PAGE_SIZE))&~(PAGE_SIZE-1)); \
	for (;p<end;p+=PAGE_SIZE,q+=PAGE_SIZE) \
		*q = *p; \
}

#define AG_munlock(buf,size)

#endif
